# This programm is copyright by Paul Sijben you can freely copy this programm
# as long as the copyright notice is maintaned as well as the pointer to the
# home page.

import sys
import posix
from string import *
from time import *
from HTMLsupport import *
from ConfigureThisOne import *

class DateSelectClass:
	def init(self):
		self.type=''
		self.year=''
		self.month=''
		self.dayrange=[]
		self.monthrange=[]
		return self

def NOofDays(number):
	tab=[31,28,31,30,31,30,31,31,30,31,30,31]
	return tab[number]

def GenDateSelect(type,contents,year):
	tmp=DateSelectClass().init()
	tmp.type=type
	if type=="range":
		tmp.dayrange=contents[0]
		tmp.monthrange=contents[1]
	elif type=="month":
		tmp.month=contents[1]
		tmp.dayrange=[contents[0]]
	tmp.year=year
	return tmp



def checkdate():
	#checks for the presence of a days field on the commandline
	if len(sys.argv)>2 and sys.argv[2][0] in digits:
		return atoi(sys.argv[2])
	else:
		return 0

def ExtractDate(regel):
		i1=find(regel,'[')
		i2=find(regel,']')
		if i1>0 and i2>i1:
			return regel[i1+1:i2]
		else:
			return ''
	
def Lday(datestring):
#get the day out of the log dataformat
	if DATEFORMAT==0:
		return day(datestring)
	elif DATEFORMAT==1:
		dummy=splitfields(datestring,"/")[0]
		if dummy[0]=='0':
			return dummy[1]
		else:
			return dummy

def Lmonth(datestring):
#get the month out of the log dataformat
	if DATEFORMAT==0:
		return month(datestring)
	elif DATEFORMAT==1:
		return splitfields(datestring,"/")[1]

def Lyear(datestring):
	if DATEFORMAT==0:
		return year(datestring)
	elif DATEFORMAT==1:
		return splitfields(datestring,"/")[2][:4]

def day(datestring):
	datum=splitfields(datestring," ")
	if datum[2]!="":
		return datum[2]
	else:
		return datum[3]

def month(datestring):
	datum=splitfields(datestring," ")
	return datum[1]

def year(datestring):
	datum=splitfields(datestring," ")
	return datum[-1]

def ranges(n,m):
	dayrange=[]
	monthrange=[]
	tijd=time()-m*60*60*24
	for i in range(-n+1,1,1):
		datum=asctime(localtime(tijd+60*60*24*i))
		dayrange.append(day(datum))
		monthrange.append(month(datum))
	return GenDateSelect('range',[dayrange,monthrange],year(datum))
