# This programm is copyright by Paul Sijben you can freely copy this programm
# as long as the copyright notice is maintaned as well as the pointer to the
# home page.

import sys
import posix
from string import *
from time import *
from ConfigureThisOne import *
from Support import *
from DateSupport import *

def CheckMonth(number):
	tab=['Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sep','Oct','Nov','Dec'] 
	if number<1 or number>12:
		print "Please specify a month in the range of 1..12."
		sys.exit(0)
	else:
		return [NOofDays(number),tab[number-1]]

def CheckYear(number):
	if number<1990:
		print "Please specify a valid year."
		sys.exit(0)
	else:
		return `number`

def printoptions():
	print "Usage: -w|-d|-m|-y [<number>] [-g <pathname>]",\
						"[-f {<filename>}]"
	print "     -w   : present seven days "
	print "     -d   : one day only"	
	print " <number> : negative offset; -d 1 means present yesterday's connections"
       	print "     -m   : month, <number> is the month number"
	print "     -y   : year, <number is the year>"
	print "     -g   : generate WWW pages for the report"
	print "     -f   : input filenames;" 
	print "            when -f is ommitted stdin is used"
	print "           .gz files are automatically uncpompressed."
	sys.exit(0) 
	
def parsecommandline():
	a=sys.argv
	if len (a)==1:
		printoptions()
	else:
		if a[1]=="-w":
			return ranges(7,checkdate())
		elif a[1]=="-d":
			return ranges(1,checkdate())
		elif a[1]=="-m": 
			return GenDateSelect('month',CheckMonth(checkdate()),year(asctime(localtime(time()))))
		elif a[1]=="-y":
			return GenDateSelect('year','*',CheckYear(checkdate()))
		else:
			printoptions()


def RANGE(tmp,DateSelect):
	return (Lmonth(tmp) in DateSelect.monthrange) and \
		(Lday(tmp) in DateSelect.dayrange)

def YEAR(tmp,DateSelect):
	return (Lyear(tmp)==DateSelect.year)

def MONTH(tmp,DateSelect):
	return (Lmonth(tmp)==DateSelect.month)	

def readandcheck(fd,regels,DateSelect):
	if DateSelect.type=='range':
		laststep=RANGE
	elif DateSelect.type=='year':
		laststep=YEAR				
	else:
		laststep=MONTH	
	while 1:
		regel=strip(fd.readline())
		if len(regel)<1:
			break
		else:
			tmp=ExtractDate(regel)
			if tmp!='' and laststep(tmp,DateSelect):
				regels.append(splitfields(regel,' '))	
	fd.close()				
					
def readinput(regels,DateSelect):
	i=2
	files=0
	while i<len(sys.argv):
		if files==1:
			fn=sys.argv[i]
			if fn[-3:]==".gz":
				fd=posix.popen('cat '+fn+'| gunzip |grep GET','r')
			else:
				fd=posix.popen('grep GET '+fn,'r')
			readandcheck(fd,regels,DateSelect)
		if sys.argv[i]=="-f":
			files=1
		i=i+1
	if files==0:
		fd=posix.popen('grep GET ','r')
		readandcheck(fd,regels,DateSelect)




	
def MinG():
	p=""
	for i in range(len(sys.argv)):
		if sys.argv[i]=="-g":
			if len(sys.argv)>i+1:
				p=sys.argv[i+1]
				posix.chdir(p)
			else:
				print "please specify a valid pathname"
				sys.exit(0)	
	return p









