# This programm is copyright by Paul Sijben you can freely copy this programm
# as long as the copyright notice is maintaned as well as the pointer to the
# home page.

import sys
import posix
from string import *
from time import *
from HTMLsupport import *
from ConfigureThisOne import *

hostdb={} 

tabel={ 'gov':'US GOVERNMENT', 'mil':'US MILITARY', 'int':'INTERNATIONAL ORGANISATION',
'org':'NON PROFIT ORGANISATIONS', 'com':'COMMERCIAL', 'net':'THE NETWORK',
'edu':'US EDUCATIONAL', 'af':'AFGHANISTAN', 'al':'ALBANIA', 'dz':'ALGERIA',
'as':'AMERICAN SAMOA', 'ad':'ANDORRA', 'ao':'ANGOLA', 'ai':'ANGUILLA',
'aq':'ANTARCTICA', 'ag':'ANTIGUA AND BARBUDA', 'ar':'ARGENTINA',
'am':'ARMENIA', 'aw':'ARUBA', 'au':'AUSTRALIA', 'at':'AUSTRIA',
'az':'AZERBAIJAN', 'bs':'BAHAMAS', 'bh':'BAHRAIN', 'bd':'BANGLADESH',
'bb':'BARBADOS', 'be':'BELGIUM', 'bz':'BELIZE', 'bj':'BENIN',
'bm':'BERMUDA', 'bt':'BHUTAN', 'bo':'BOLIVIA', 'ba':'BOSNIA HERCEGOVINA', 
'bw':'BOTSWANA', 'bv':'BOUVET ISLAND', 'br':'BRAZIL',
'io':'BRITISH INDIAN OCEAN TERRITORY', 'bn':'BRUNEI DARUSSALAM',
'bg':'BULGARIA', 'bf':'BURKINA FASO', 'bi':'BURUNDI', 'by':'BELARUS',
'kh':'CAMBODIA', 'cm':'CAMEROON', 'ca':'CANADA', 'cv':'CAPE VERDE',
'ky':'CAYMAN ISLANDS', 'cf':'CENTRAL AFRICAN REPUBLIC', 'td':'CHAD',
'cl':'CHILE', 'cn':'CHINA', 'cx':'CHRISTMAS ISLAND', 
'cc':'COCOS (KEELING) ISLANDS', 'co':'COLOMBIA', 'km':'COMOROS', 'cg':'CONGO',
'ck':'COOK ISLANDS', 'cr':'COSTA RICA', 'ci':'COTE D\'IVOIRE',
'hr':'CROATIA', 'cu':'CUBA', 'cy':'CYPRUS', 'cz':'CZECH REPUBLIC',
'cs':'CZECHOSLOVAKIA', 'dk':'DENMARK', 'dj':'DJIBOUTI',
'dm':'DOMINICA', 'do':'DOMINICAN REPUBLIC', 'tp':'EAST TIMOR',
'ec':'ECUADOR', 'eg':'EGYPT', 'sv':'EL SALVADOR', 
'gq':'EQUATORIAL GUINEA', 'ee':'ESTONIA', 'et':'ETHIOPIA',
'fk':'FALKLAND ISLANDS (MALVINAS)', 'fo':'FAROE ISLANDS', 'fj':'FIJI',
'fi':'FINLAND', 'fr':'FRANCE', 'gf':'FRENCH GUIANA', 'pf':'FRENCH POLYNESIA',
'tf':'FRENCH SOUTHERN TERRITORIES', 'ga':'GABON', 'gm':'GAMBIA',
'ge':'GEORGIA', 'de':'GERMANY', 'gh':'GHANA', 'gi':'GIBRALTAR',
'gr':'GREECE', 'gl':'GREENLAND', 'gd':'GRENADA', 'gp':'GUADELOUPE',
'gu':'GUAM', 'gt':'GUATEMALA', 'gn':'GUINEA', 'gw':'GUINEA-BISSAU',
'gy':'GUYANA', 'ht':'HAITI', 'hm':'HEARD AND MC DONALD ISLANDS',
'hn':'HONDURAS', 'hk':'HONG KONG', 'hu':'HUNGARY', 'is':'ICELAND',
'in':'INDIA', 'id':'INDONESIA', 'ir':'IRAN (ISLAMIC REPUBLIC OF)',
'iq':'IRAQ', 'ie':'IRELAND', 'il':'ISRAEL', 'it':'ITALY',
'jm':'JAMAICA', 'jp':'JAPAN', 'jo':'JORDAN', 'ka':'KAZAKHSTAN',
'ke':'KENYA', 'ki':'KIRIBATI', 'kp':'KOREA, DEMOCRATIC PEOPLE\'S REPUBLIC OF',
'kr':'KOREA, REPUBLIC OF', 'kw':'KUWAIT',
'kg':'KYRGYZSTAN', 'la':'LAO PEOPLE\'S DEMOCRATIC REPUBLIC',
'lv':'LATVIA', 'lb':'LEBANON', 'ls':'LESOTHO', 'lr':'LIBERIA',
'ly':'LIBYAN ARAB JAMAHIRIYA', 'li':'LIECHTENSTEIN', 'lt':'LITHUANIA',
'lu':'LUXEMBOURG', 'mo':'MACAU', 'mg':'MADAGASCAR', 'mw':'MALAWI',
'my':'MALAYSIA', 'mv':'MALDIVES', 'ml':'MALI', 'mt':'MALTA',
'mh':'MARSHALL ISLANDS', 'mq':'MARTINIQUE', 'mr':'MAURITANIA',
'mu':'MAURITIUS', 'mx':'MEXICO', 'fm':'MICRONESIA', 
'md':'MOLDOVA, REPUBLIC OF', 'mc':'MONACO', 'mn':'MONGOLIA', 'ms':'MONTSERRAT',
'ma':'MOROCCO', 'mz':'MOZAMBIQUE', 'mm':'MYANMAR', 'na':'NAMIBIA',
'nr':'NAURU', 'np':'NEPAL', 'nl':'NETHERLANDS', 'an':'NETHERLANDS ANTILLES', 
'nt':'NEUTRAL ZONE', 'nc':'NEW CALEDONIA', 'nz':'NEW ZEALAND', 
'ni':'NICARAGUA', 'ne':'NIGER', 'ng':'NIGERIA', 'nu':'NIUE',
'nf':'NORFOLK ISLAND', 'mp':'NORTHERN MARIANA ISLANDS', 'no':'NORWAY',
'om':'OMAN', 'pk':'PAKISTAN', 'pw':'PALAU', 'pa':'PANAMA', 
'pg':'PAPUA NEW GUINEA', 'py':'PARAGUAY', 'pe':'PERU', 'ph':'PHILIPPINES',
'pn':'PITCAIRN', 'pl':'POLAND', 'pt':'PORTUGAL', 'pr':'PUERTO RICO',
'qa':'QATAR', 're':'REUNION', 'ro':'ROMANIA', 'ru':'RUSSIAN FEDERATION', 
'rw':'RWANDA', 'sh':'ST. HELENA', 'kn':'SAINT KITTS AND NEVIS', 
'lc':'SAINT LUCIA', 'pm':'ST. PIERRE AND MIQUELON',
'vc':'SAINT VINCENT AND THE GRENADINES', 'ws':'SAMOA', 'sm':'SAN MARINO', 
'st':'SAO TOME AND PRINCIPE', 'sa':'SAUDI ARABIA', 'sn':'SENEGAL', 
'sc':'SEYCHELLES', 'sl':'SIERRA LEONE', 'sg':'SINGAPORE', 'sk':'SLOVAKIA', 
'si':'SLOVENIA', 'sb':'SOLOMON ISLANDS', 'so':'SOMALIA', 'za':'SOUTH AFRICA', 
'es':'SPAIN', 'lk':'SRI LANKA', 'sd':'SUDAN', 'sr':'SURINAME', 
'sj':'SVALBARD AND JAN MAYEN ISLANDS', 'sz':'SWAZILAND', 'se':'SWEDEN', 
'ch':'SWITZERLAND', 'sy':'SYRIAN ARAB REPUBLIC', 'tw':'TAIWAN',
'tj':'TAJIKISTAN', 'tz':'TANZANIA, UNITED REPUBLIC OF', 'th':'THAILAND', 
'tg':'TOGO', 'tk':'TOKELAU', 'to':'TONGA', 'tt':'TRINIDAD AND TOBAGO', 
'tn':'TUNISIA', 'tr':'TURKEY', 'tm':'TURKMENISTAN', 
'tc':'TURKS AND CAICOS ISLANDS', 'tv':'TUVALU', 'ug':'UGANDA', 'ua':'UKRAINE',
'ae':'UNITED ARAB EMIRATES', 'uk':'UNITED KINGDOM', 'us':'UNITED STATES', 
'um':'UNITED STATES MINOR OUTLYING ISLANDS', 'uy':'URUGUAY', 'su':'USSR', 
'uz':'UZBEKISTAN', 'vu':'VANUATU', 'va':'VATICAN CITY',
've':'VENEZUELA', 'vn':'VIET NAM', 'vg':'VIRGIN ISLANDS (BRITISH)',
'vi':'VIRGIN ISLANDS (U.S.)', 'wf':'WALLIS AND FUTUNA ISLANDS',
'eh':'WESTERN SAHARA', 'ye':'YEMEN, REPUBLIC OF', 'yu':'YUGOSLAVIA',
'zr':'ZAIRE', 'zm':'ZAMBIA', 'zw':'ZIMBABWE' }

def spc(i):
	a=""
	for i in range(i):
		a=a+' '
	return a

def alldigits(string):
	for j in range(len(string)):
		if not string[j] in digits:
			return 0
	return 1

def IPaddress(string):
	a=splitfields(string,'.')
	#check for all digits and dots
	for i in a:
		if not alldigits(i):
			return 0
	return 1

def check_inaddr(string,hostname):
	if string[-13:]=='.in-addr.arpa':
		#oho, this is some BROKEN nameserver
		tmp=splitfields(string[:-13],'.')
		teller=len(tmp)
		while teller>0 and alldigits(tmp[teller-1]):
			teller=teller-1
		if teller<2:
			return hostname
		else:
			return joinfields(tmp[:teller],'.')
	return string

def ReverseAdrress(hostname):
	if hostdb.has_key(hostname):
		return 	hostdb[hostname]
	outp=hostname
	rev=swap(hostname)+".in-addr.arpa."	
	fd=posix.popen("nslookup 2>&1 -q=ptr "+rev+" |grep "+rev,'r')
	inp0=fd.readlines()
	dummy=fd.close()
	if len(inp0)>0:
		inp=split(inp0[0])
		if inp[0]!='***':
			outp= inp[-1]
			outp=check_inaddr(outp,hostname)
	hostdb[hostname]=outp
	#print outp
	return outp
	


def swap(item):
	a=splitfields(item,'.')	
	l=len(a)/2 #int!!!!
	for i in range(l):
		b=a[i]
		a[i]=a[-(1+i)]
		a[-(1+i)]=b
	return joinfields(a,'.')	

def swapfields(item):
	#if IP address don't swap
	if IPaddress(item):
		return item
	#if domainname do swap
	return swap(item)

def revsort(list):
	for i in range(len(list)):
		list[i]=swapfields(list[i])
	list.sort()
	for i in range(len(list)):
		list[i]=swapfields(list[i])

def allzeros(number):
	tmp=[]
	for i in range(number):
		tmp.append(0)
	return tmp

def top(n,fromlist):
	l=[]
	for i in range(n):
		l.append("",0)
	for i in fromlist.keys():
		aant=fromlist[i][-1]
		j=n
		gev=0
		while j>0 and aant>l[j-1][1]:
			gev=1
			j=j-1
		if gev==1:
			l.remove(l[-1])
			l.insert(j,(i,aant))
	return l

def Country(fromlist):
# return a list with numbers per country from fromlist
# ignore unresolvable names
	l={}
	for i in fromlist.keys():  
		if i[0] in letters:
			country=lower(splitfields(i,'.')[-1])
			if l.has_key(country)==0:
				l[country]=(allzeros(1))
			l[country][-1]=l[country][-1]+fromlist[i][-1]
	return l
			


def FullName(afko):
#return the full name of a country
	if tabel.has_key(afko):
		return tabel[afko]
	else:
		print "Error, don\'t know domain "+afko
		return afko+" (oops don\'t know this one)"

