#
# Configure in this file the services you whish to recognise.
#
# Place in sservices the strings you want to look for (in the order you
# want the program to look for them!)
# place in services the full names of the services as they will appear
# in the full listing.
# next specify in firstmap the mapping from the sservices to services
# the string that is found in the first position (0) in services corresponds  
# to services[firstmap[0]] 
# things that so not fit sservices will correcpond to services[firstother]
#
# In names a list of full names is given as they will appear in the WWW
# pages. They have the same order as services. When names is shorter than 
# services the remaining usage numbers are added to the last one in names.
#  
#
#strings to grep for in the log file
sservices=['refdbms', 'pgp', 'campus','statistics', 'weather', 'finger?ab.',\
			'finger?', 'people','~','default','pegasus.gif']

#names as they appear on the full listing
services=['refdbms', 'pgp', 'campus', 'statistics','weather', 'badge',\
			'finger', 'people','others','default','pegasus.gif']

#mappings for sservices to services
firstmap=[0,1,2,3,4,5,6,7,7,9,10]
#map the remaining pages to ...
firstothers=8


#names as they appear on the report WWW pages. Use the same order as in services
#put 'Others' (or similar description) at the end!
names=['Refdbms service', 'PGP docuentation', \
		'Campus information pages','Statistics pages',\
		 'Weather images',\
		'Badge system', 'Fingers on persons directly',\
		'Private pages of people', 'Others']

#pointer to the maintainer of these mages
MAINTAINERp="HREF=\"http://www.pegasus.esprit.ec.org/people/sijben/index.html\""
MAINTAINERn="Paul Sijben."

#pointer to the image that is displayed on the top page.
IMAGE="http://www.pegasus.esprit.ec.org/pegasus.gif"
#room for hostname in full length output
maxlenhostname=27

#What is the format of your log?

#Where is the requested page to be found?
PAGEPLACE=-4 
# -1 the last but one
#NCSA HTTPD-1.3 has -4

# How are dates represented in your logs?
DATEFORMAT=1
# 0like this:[Fri Jul 29 12:01:08 1994]
# 1 #like this [03/Aug/1994:15:24:52 +0100]
 
#How are the date ordered in the index page
REVERSESORT=1 # 1=newest first, 0=oldest first 
 
