# This programm is copyright by Paul Sijben you can freely copy this programm
# as long as the copyright notice is maintaned as well as the pointer to the
# home page.

import sys
import posix
from string import *
from time import *
from HTMLsupport import *
from ConfigureThisOne import *
from Support import *
from DateSupport import *


def Period(DateSelect):
	str=""
	if DateSelect.type=='range' and len(DateSelect.dayrange)==1:
		str=str+"on"+DateSelect.dayrange[0]+' '+DateSelect.monthrange[0]
	else:
		str=str+ "during "
		if DateSelect.type=='month':
			str=str+DateSelect.month+' '+DateSelect.year
		elif DateSelect.type=='year':
			str=str+DateSelect.year
		else:
			str=str+ "the week from "+DateSelect.dayrange[0]
			if  DateSelect.monthrange[0]!= DateSelect.monthrange[-1]:
				str=str+" "+ DateSelect.monthrange[0]
			str=str+ " to "+DateSelect.dayrange[-1]+' '+DateSelect.monthrange[-1]
	return str

def FN(type,DateSelect):
	fn=type
	if DateSelect.type=='year':
		fn=fn+".1.Jan.-.31.Dec"
	elif DateSelect.type=='month':
		fn=fn+".1."+DateSelect.month+".-."+`DateSelect.dayrange[0]`\
			+"."+DateSelect.month
	else:
		fn=fn+"."+DateSelect.dayrange[0]+"."+DateSelect.monthrange[0]+".-."+\
		DateSelect.dayrange[-1]+"."+DateSelect.monthrange[-1]
	fn=fn+"."+DateSelect.year+".html"
	return fn

def NewWWWpage(aantallen,fromlist ,DateSelect):
	fd=open(FN('report',DateSelect),"w")
	TITLE(fd,"WWWserver report")
	str="Actions on the server "+Period(DateSelect)
	H1(fd,str)
	PHR(fd)
	H2(fd,"This is the list of number of usages of the server per type:")
	P(fd)
	str=""
	tot=0
	numberofnames=len(names)
	for i in range(numberofnames-1):
		tot=tot+aantallen[i] 
		str=str+names[i]+":"+spc(30-len(names[i]))+\
			rjust(`aantallen[i]`,4)+"\n"
	res=0
	for i in range((numberofnames-1)-len(aantallen),0):
		res=res+aantallen[i]
	tot=tot+res
	str=str+names[-1]+":"+spc(30-len(names[-1]))+rjust(`res`,4)+"\n"
	PRE(fd,str)
	P(fd)
	fd.write("There have been <B>"+`tot`+"</B> accesses to the server.\n")
	P(fd)
	PHR(fd)
	H2(fd,"Of these accesses the top 10 using domains were:")
	P(fd)
	str=""	
	l=top(10,fromlist)
	for i in l:
		if i[1]!=0:
			str=str+i[0]+":"+spc(30-len(i[0]))+rjust(`i[1]`,4)+'\n'
	PRE(fd,str)
	PHR(fd)
	H2(fd,"Where do we get connections from?:")
	P(fd)
	str=""
	templ=Country(fromlist)	
	l=top(len(templ),templ)
	for i in l:
		if i[1]!=0:
			country=FullName(i[0])
			str=str+country+":"+spc(30-len(country))+rjust(`i[1]`,4)+"\n"
			
	PRE(fd,str)
	PHR(fd)
	H2(fd,"Usage per page")
	listp=FN("list",DateSelect)
	A(fd,"HREF=\""+listp+"\"",'Clicking on this line gives you the usage per page.')	
	PHR(fd)
	A(fd,MAINTAINERp,MAINTAINERn)
	fd.close()

def NewListPage(tolist ,DateSelect):
	fd=open(FN('list',DateSelect),"w")
	TITLE(fd,"WWWserver report")
	str="Actions on the server "+Period(DateSelect)
	H1(fd,str)
	PHR(fd)
	H2(fd,"This is the list of number of usages of the server per page:")
	P(fd)
	burb=tolist.keys()
	burb.sort()
	for i in burb:
		PRE(fd, rjust(`tolist[i]`,4)+' '+i)
	
	PHR(fd)
	A(fd,MAINTAINERp,MAINTAINERn)
	fd.close()

def NewTopPage():
	tab={"Jan":"01","Feb":"02","Mar":"03","Apr":"04","May":"05","Jun":"06",\
	   "Jul":"07","Aug":"08","Sep":"09","Oct":"10","Nov":"11","Dec":"12"}
	directory=posix.listdir(".")
	l={}
	for i in directory:
		a=splitfields(i,".")
		if a[0]=='report':
			blub=a[-4]
			if len(blub)==1:
				blub='0'+blub
			digest=a[-2]+tab[a[-3]]+blub
			title=joinfields(a[1:7],' ')
			l[digest]=(title,i)
	k=l.keys()
	k.sort()
	if REVERSESORT==1:
		k.reverse()
		latest=l[k[0]][1]
	else:
		latest=l[k[-1]][1]
	fd=open("index.html","w")
	TITLE(fd,"Usage reports")
        IMG(fd,IMAGE)
	H1(fd,"Reports on the usage of this WWW server")		
	P(fd)
	fd.write("We keep track of usage of this WWW server.")
	fd.write(" The summarised reports are automatically placed here.")
	P(fd)
	fd.write("Click ")
	A(fd,"HREF=\"http:./"+latest+"\"","here")
	fd.write(" for the latest report.") 
	PHR(fd)
	H2(fd,"Click on one of the date ranges to see the usage report of that week.")
	fd.write("<UL>")	
	for i in k:
		fd.write("<LI>")
		A(fd,"HREF=\"http:./"+l[i][1]+"\"",l[i][0])
		#P(fd)
		fd.write("\n")
	fd.write("</UL>")
	PHR(fd)
	A(fd,MAINTAINERp,MAINTAINERn)
	PHR(fd)
	fd.write("These pages were created using ")
	A(fd,"HREF=\"http://www.pegasus.esprit.ec.org/people/sijben/statistics/advertisment.html\"","WebStat")
	fd.write(" 1.7 by <A HREF=\"http://www.pegasus.esprit.ec.org/people/sijben/index.html\">Paul Sijben. </A>")
	fd.close()
