#!/usr/local/bin/python
# Author: Paul Sijben (sijben@pegasus.esprit.ec.org)
# Version 1.7
# date 25 aug 1994
#
# This programm is copyright by Paul Sijben you can freely copy this programm
# as long as the copyright notice is maintaned as well as the pointer to the
# home page.

import sys
import posix
from string import *
from time import *
from HTMLsupport import *
from ConfigureThisOne import *
from Support import *
from DateSupport import *
from GenWWW import *	
from Input import *

def GenReport(aantallen,fromlist, tolist,DateSelect):
	p=MinG()
	if p!="":
		NewWWWpage(aantallen,fromlist,DateSelect)	
		NewListPage(tolist ,DateSelect)
		NewTopPage()

def printoutput(aantallen,fromlist ,DateSelect):	
	print "Overview of connections made to the WWW server made"
	print Period(DateSelect)
	#
	#print services vertically
	#
	for i in range(7):
		print spc(maxlenhostname+1),
		for j in range(len(services)+1):
			if j==len(services):
				stringje="TOTALS"
				print "|  ",
			else:
				stringje=services[j]
			if len(stringje)>i:
				print stringje[i],spc(1),
			else:
				print spc(3),
		print
	#
	#make seperationline 
	#
	seperationline=""
	for i in range(maxlenhostname):
		seperationline=seperationline+"-"
	for i in services:
		seperationline=seperationline+"----"
	seperationline=seperationline+"--+------"
	print seperationline
	#
	#produce a list of all domains
	#
	lijst=fromlist.keys()
	#
	# and sort it (minding the significance of the fields)
	#
	revsort(lijst)
	#
	# print domainname embedded in 'maxlenhostname' whitespaces 
	#  followed by the numbers of usages and the total
	#
	for i in lijst:
		if i[-1] in digits:
			print spc(maxlenhostname-12),
			print ljust(i,11),
		else:
			print rjust(i,maxlenhostname),
		for j in range(len(aantallen)):
			print center(`fromlist[i][j]`,3),
		print " |",rjust(`fromlist[i][-1]`,3)
	print seperationline
	#
	# print the totals
	#
	print rjust("TOTALS",maxlenhostname),
	tot=0
	for j in range(len(aantallen)):
		print center(`aantallen[j]`,3),
		tot=tot+aantallen[j]
	print " |",rjust(`tot`,3)
		

def aggregate(tolist,fromlist,aantallen,regels):
	for i in range(len(regels)):
		tmp=regels[i]
		van=tmp[0] # the hostname
		#if a local host does not give a full hostname, 
		# append domainname
		if find(van,'.')==-1:
			van=van+'.'+posix.environ['DOMAIN']
		if IPaddress(van):
			#try and get the reverse address mapping
			van=ReverseAdrress(van)
		else:
			van=check_inaddr(van,van)
		if len(splitfields(van,'.'))>2:
			if IPaddress(van):
				van=van[:rindex(van,'.')]
			else:
				van=van[index(van,'.')+1:]
		if fromlist.has_key(van)==0:
			fromlist[van]=(allzeros(len(services)+1))
		page=tmp[PAGEPLACE]
		if page=='GET': #the server goofed up
			page=tmp[PAGEPLACE+1]	
		page=splitfields(page,'?')[0]
		if tolist.has_key(page):
			tolist[page]=tolist[page]+1
		else:
			tolist[page]=1
		for j in range(len(sservices)):
			if find(page,sservices[j])!=-1:
				k=firstmap[j]	
				break
		else:
			k=firstothers	
		aantallen[k]=aantallen[k]+1
		fromlist[van][k]=fromlist[van][k]+1	
		fromlist[van][-1]=fromlist[van][-1]+1	

def main():
	DateSelect=parsecommandline()
	regels=[]
	readinput(regels,DateSelect)
	fromlist={}
	tolist={}
	aantallen=allzeros(len(services))
	aggregate(tolist,fromlist,aantallen,regels)
	GenReport(aantallen,fromlist,tolist,DateSelect)
	printoutput(aantallen,fromlist,DateSelect)


main()




